Imports System
Imports System.Threading
Imports System.ServiceProcess
Imports System.Diagnostics
Imports System.Configuration
Imports System.Reflection

' Todo before using service:
' 1. Rename TestService.vb and TestService.exe.config to <YourServiceName>.vb and <YourServiceName>.exe.config (no spaces in the name, please)
' 2. Do a search/replace on all instances of the string "TestService" in this source file to name your service. Use the same <YourServiceName> as in step 1
' 3. Set the service process account (Me.ServiceProcessInstaller1.Account) to either "ServiceAccount.NetworkService", "ServiceAccount.LocalService", "ServiceAccount.LocalSystem" or "ServiceAccount.User" according to your security design. Note that the NetworkService and LocalService accounts may need explicit read/execute NTFS permissions on the folder containing the service files for the service to be allowed to start
' 4. Set ActionInterval in the .config file. This determines the interval in seconds between your service payload code execution
' 5. Add your code and functions to <YourServiceName>.vb. The payload execution starts in the function RunPayload()
' 6. Run Compile.vbs to build <YourServiceName>.exe
' 7. Run ServiceInstall.vbs to install the service. There is also a corresponding ServiceUnInstall.vbs that can be used to uninstall the service
' 8. Look in the Windows application event log for messages from the service

<Assembly: AssemblyTitle("TestService")>
<Assembly: AssemblyDescription(".NET Windows Test Service")>
<Assembly: AssemblyCompany("MyCompanyName")>
<Assembly: AssemblyProduct("TestService")>
<Assembly: AssemblyCopyright("Copyright (C) MyCompanyName")>
<Assembly: AssemblyVersion("1.0.0.0")>
<Assembly: CLSCompliant(True)>

Public Class TestService

  Private Shared ServiceThread As Thread
  Private Shared PollingInterval As Integer = 10000
  Private Shared ActionInterval As Integer = ConfigurationManager.AppSettings("ActionInterval")
  Private Shared KeepRunning As Boolean = True

  Public Sub RunPayload()
    ' Put your service payload code and/or function calls here. For example:
    Try
      WriteToEventLog("TestService payload execution", 1000)
    Catch e As Exception
      WriteToEventLog("An error occurred: " & e.Message, 2000, EventLogEntryType.Error)
    End Try
  End Sub

  Public Sub StartWorkerThread()
    Dim WorkerThread As Thread = New Thread(AddressOf RunPayload)
    WorkerThread.Name = "TestService payload thread"
    WorkerThread.Start()
  End Sub

  Public Sub RunScheduler()
    Dim LastActionTime As Date = DateAdd(DateInterval.Day, -1, Date.Now)
    Do While KeepRunning
      If DateDiff(DateInterval.Second, LastActionTime, Date.Now) >= ActionInterval Then
        LastActionTime = Date.Now
        StartWorkerThread()
      End If
      Thread.Sleep(PollingInterval)
    Loop
  End Sub

  Public Function WriteToEventLog( _
      ByVal Entry As String, _
      Optional ByVal EventID As Integer = 0, _
      Optional ByVal EventType As EventLogEntryType = EventLogEntryType.Information, _
      Optional ByVal AppName As String = "TestService", _
      Optional ByVal LogName As String = "Application") As Boolean
    Dim objEventLog As New EventLog()
    Try
      If Not Diagnostics.EventLog.SourceExists(AppName) Then
        Diagnostics.EventLog.CreateEventSource(AppName, LogName)
      End If
      objEventLog.Source = AppName
      objEventLog.WriteEntry(Entry, EventType, EventID)
      Return True
    Catch Ex As Exception
      Return False
    End Try
    objEventLog.Dispose()
  End Function

  Protected Overrides Sub OnStart(ByVal args() As String)
    WriteToEventLog("TestService starting", 1000)
    ServiceThread = New Thread(AddressOf RunScheduler)
    ServiceThread.Name = "TestService scheduler thread"
    ServiceThread.Start()
  End Sub

  Protected Overrides Sub OnStop()
    KeepRunning = False
    WriteToEventLog("TestService stopping. " & _
      "Please note: the worker process will live on for up to " & _
      PollingInterval / 1000 & " seconds before it terminates.", 1000)
  End Sub

End Class

<System.ComponentModel.RunInstaller(True)> _
Public Class ProjectInstaller
  Inherits System.Configuration.Install.Installer

  Public Sub New()
    MyBase.New()
    InitializeComponent()
  End Sub

  Private components As System.ComponentModel.IContainer

  Private Sub InitializeComponent()
    Me.ServiceProcessInstaller1 = New ServiceProcessInstaller
    Me.ServiceInstaller1 = New ServiceInstaller
    Me.ServiceProcessInstaller1.Account = ServiceAccount.LocalSystem
    Me.ServiceProcessInstaller1.Password = Nothing
    Me.ServiceProcessInstaller1.Username = Nothing
    Me.ServiceInstaller1.ServiceName = "TestService"
    Me.ServiceInstaller1.StartType = ServiceStartMode.Automatic
    Me.Installers.AddRange(New System.Configuration.Install.Installer() {Me.ServiceProcessInstaller1, Me.ServiceInstaller1})
  End Sub
  Friend WithEvents ServiceProcessInstaller1 As ServiceProcessInstaller
  Friend WithEvents ServiceInstaller1 As ServiceInstaller

End Class

<Global.Microsoft.VisualBasic.CompilerServices.DesignerGenerated()> _
Partial Class TestService
  Inherits System.ServiceProcess.ServiceBase

  <System.Diagnostics.DebuggerNonUserCode()> _
  Protected Overrides Sub Dispose(ByVal disposing As Boolean)
    Try
      If disposing AndAlso components IsNot Nothing Then
        components.Dispose()
      End If
    Finally
      MyBase.Dispose(disposing)
    End Try
  End Sub

  <MTAThread()> _
  <System.Diagnostics.DebuggerNonUserCode()> _
  Shared Sub Main()
    Dim ServicesToRun() As System.ServiceProcess.ServiceBase
    ServicesToRun = New System.ServiceProcess.ServiceBase() {New TestService}
    System.ServiceProcess.ServiceBase.Run(ServicesToRun)
  End Sub

  Private components As System.ComponentModel.IContainer

  <System.Diagnostics.DebuggerStepThrough()> _
  Private Sub InitializeComponent()
    components = New System.ComponentModel.Container()
    Me.ServiceName = "TestService"
  End Sub

End Class